// www.sunandshadows.com
// v1.0

$missionName = "Black Ice";
exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
$server::HudMapViewOffsetX = 2000;
$server::HudMapViewOffsetY = 2000;

function setDefaultMissionOptions(){
 $server::TeamPlay = false;
 $server::AllowDeathmatch = true;
 $server::AllowTeamPlay = true;
 $server::AllowTeamRed = true;
 $server::AllowTeamBlue = true;
 $server::AllowTeamYellow = true;
 $server::AllowTeamPurple = true; }

function onMissionLoad(){ cdAudioCycle("SS3", "SS4", "SS3"); }

function outerplanetSounds(){
 meteorSounds();
 %weather1 = getObjectId("MissionGroup\\World\\sky");
 createAmbientSoundSource(%weather1, 0, 10, 12);
 addToAmbientSoundSource(%weather1, "sfx_radar_station.wav", IDPRF_2D); }
 
function onMissionStart(){
 $itemWave = getObjectId("MissionGroup\\ItemGroup\\Wave");
 $ksatBeam = getObjectId("MissionGroup\\ItemGroup\\ksatBeam");
 $beamTrigger = getObjectId("MissionGroup\\ItemGroup\\activatebeam");
 $enableTeamHittingPenalty = true;
 outerplanetSounds(); }

function zenbunker::trigger::onEnter(%this, %object){ Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true); }

function zenbunker::trigger::onContact(%this, %object){
 Zen::work(%this, %object, $yellowZenHealRate, $yellowZenAmmoRate, $zenWaitTime, true);
 if(isShutDown(%object)){
  if(%object != $lastVehicleOnZen){
   $lastVehicleOnZen = %object;
   $secondsToGain = 1; }
  else{ $secondsToGain = $secondsToGain + 1; }
  if($secondsToGain >= 4){ giveTurretsToThisGuy(%object); } } }

echo("zenbunker");

function giveTurretsToThisGuy(%vehicleId){
 %team = getTeam(%vehicleId);
 setTeam("MissionGroup\\bunker\\1", %team);
 order("MissionGroup\\CenterStructures", Shutdown, false); }

function zencenter::trigger::onEnter(%this, %object){
 animatepower(%object, true);
 Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true); }

function zencenter::trigger::onLeave(%this, %object){
 animatepower(%object, false);
 Zen::onLeave(%this, %object); }

function zencenter::trigger::onContact(%this, %object){ Zen::work(%this, %object, $yellowZenHealRate, $yellowZenAmmoRate, $zenWaitTime, true); }

function animatePower(%who, %bool){
 %team = getteam(%who);
 echo("animating "@%team@", "@%bool@".");
 if(%team == *IDSTR_TEAM_YELLOW){ playAnimSequence(getObjectId("MissionGroup\\center\\YELLOW"), 0, %bool); }
 else if(%team == *IDSTR_TEAM_BLUE){ playAnimSequence(getObjectId("MissionGroup\\center\\BLUE"), 0, %bool); }
 else if(%team == *IDSTR_TEAM_RED){ playAnimSequence(getObjectId("MissionGroup\\center\\RED"), 0, %bool); }
 else if(%team == *IDSTR_TEAM_PURPLE){ playAnimSequence(getObjectId("MissionGroup\\center\\PURPLE"), 0, %bool); } }
 
function backhome::trigger::oncontact(%this, %v){ redrop(%v); }

function activateturrets::trigger::onenter(%this, %v){
 setteam("MissionGroup\\weapon\\1", *IDSTR_TEAM_YELLOW);
 setteam("MissionGroup\\weapon\\2", *IDSTR_TEAM_RED);
 setteam("MissionGroup\\weapon\\3", *IDSTR_TEAM_BLUE);
 setteam("MissionGroup\\weapon\\4", *IDSTR_TEAM_PURPLE);
 %v.inturrettrigger = true; }
 
function activateturrets::trigger::onleave(%this, %v){
 schedule("neutralizeturrets();", 5);
 %v.inturrettrigger = false; }

function activatebeam::trigger::onenter(%this, %v){
 setposition("MissionGroup\\weapon\\beam", 500, 2700, 100);
 say(%player, %player, "<F4>Masarmax JHovi uplink activated. <F5>Masarmax JHovi si esiz oni.");
 if($beamtrigger.active == ""){ $beamtrigger.active = 0; }
 $beamtrigger.active++;
 %v.inbeamtrigger = true; }

function activatebeam::trigger::onleave(%this, %v){
 $beamtrigger.active = $beamtrigger.active - 1;
 if($beamtrigger.active == 0){ setposition("MissionGroup\\weapon\\beam", 500, 2700, 10000); }
 %v.inbeamtrigger = false; }

function tightbeam::structure::onscan(%this, %v){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 say(%player, %player, "<F4>Masarmax JHovi login sequence accepted, "@getname(%player)@". <F5>Masarmax JHovi si respondiz.");
 %v.login = true;
 schedule("neutralizeturrets();", 5); }

function tightbeam2::structure::onscan(%this, %v){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 say(%player, %player, "<F4>Masarmax JHovi login sequence accepted., "@getname(%player)@". <F5>Masarmax JHovi si respondiz.");
 %v.login = true;
 schedule("neutralizeturrets();", 5); }

function panel1::structure::onscan(%this, %v){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 say(0, 0, "<F4>Masarmax JHovi priority override sequence accepted, "@getname(%player)@". <F5>Masarmax JHovi si axeptiz komandaz.");
 %v.override = true; }

function panel2::structure::onscan(%this, %v){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%v.override != true || %v.login != true || %v.inbeamtrigger != true){
  say(%player, %player, "<F4>Masarmax JHovi activation sequence rejected!, "@getname(%player)@".  Security protocols online!");
  damageobject(%v, 100000);
  return; }
 %v.override = false;
 %v.login = false;
 say(%player, %player, "<F4>Masarmax JHovi activation sequence accepted, "@getname(%player)@". <F5>Masarmax JHovi si esiz energi'iz.");
 setteam("MissionGroup\\weapon\\1", *IDSTR_TEAM_YELLOW);
 setteam("MissionGroup\\weapon\\2", *IDSTR_TEAM_RED);
 setteam("MissionGroup\\weapon\\3", *IDSTR_TEAM_BLUE);
 setteam("MissionGroup\\weapon\\4", *IDSTR_TEAM_PURPLE);
 doksat(%v); }

function neutralizeturrets(){
 setteam("MissionGroup\\weapon\\1", *IDSTR_TEAM_NEUTRAL);
 setteam("MissionGroup\\weapon\\2", *IDSTR_TEAM_NEUTRAL);
 setteam("MissionGroup\\weapon\\3", *IDSTR_TEAM_NEUTRAL);
 setteam("MissionGroup\\weapon\\4", *IDSTR_TEAM_NEUTRAL); }

echo("beamstuff");

function doKSat(%vehicleID){
 %player = playermanager::vehicleIdtoPlayerNum(%vehicleID);
 if(getPosition(getVehicleNavMarkerId(%vehicleId))=="0.000000 0.000000 0.000000"){
  say(%player,%player,"<f5>Masarmax JHovi requires target coordinates.  Place a nav point.");
  return; }
 if($lastKSAT==""){
  $lastKSAT=%player;
  %wave = copyObject($itemWave);
  addToset(%player.group,%wave);
  %nav = getVehicleNavMarkerId(%vehicleId);
  %x = getposition(%nav,x);
  %y = getposition(%nav,y);
  %z = getTerrainHeight(%x,%y);
  say(0,83,"<f5>!Danger!  !Masarmax JHovi firing sequence detected!","warn_missl_lock.wav");
  schedule("flushChannel(83);",0.65);
  setposition("MissionGroup\\weapon\\beam", 500, 2700, 10000);
  setPosition($ksatBeam, 500, 2700, 100);
  setHudTimer(10,-1,"Armax si spekti: ",2,%player);
  playSound(0,"sfx_quake.wav",IDPRF_2D);
  schedule("playSound(0,\"sfx_quake.wav\",IDPRF_2D);",3);
  schedule("setPosition($ksatBeam,"@%x@","@%y@","@%z@"-100);",5);
  schedule("playSound(0,\"plasma3.wav\",IDPRF_2D);",5);
  schedule("playSound(0,\"sfx_quake.wav\",IDPRF_2D);",6);
  schedule("playSound(0,\"sfx_quake.wav\",IDPRF_2D);",7);
  schedule("dropPod("@%x@","@%y@","@%z+800@","@%x@","@%y@","@%z@");",8);
  schedule("playSound(0,\"sfx_quake.wav\",IDPRF_2D);",8);
  schedule("playSound(0,\"sfx_quake.wav\",IDPRF_2D);",9);
  schedule("playSound(0,\"sfx_prob.wav\",IDPRF_2D);",10);
  schedule("playSound(0,\"sfx_fog.wav\",IDPRF_2D);",10);
  schedule("playSound(0,\"sfx_thunder1.wav\",IDPRF_2D);",10);
  schedule("playSound(0,\"sfx_thunder2.wav\",IDPRF_2D);",10);
  schedule("setPosition("@%wave@","@%x@","@%y@","@%z+3@");",9.5);
  schedule("neutralizeturrets();", 10);
  schedule("damageArea("@%wave@",0,0,0,300,999999999);",10.5);
  schedule("damageArea("@%wave@",75,0,0,100,999999999);",10.5);
  schedule("damageArea("@%wave@",-75,0,0,100,999999999);",10.5);
  schedule("damageArea("@%wave@",0,75,0,100,999999999);",10.5);
  schedule("damageArea("@%wave@",0,-75,0,100,999999999);",10.5);
  schedule("playAnimSequence("@%wave@",0,true);",9.5);
  schedule("deleteObject("@%wave@");",11.667);
  schedule("playSound(0,\"sfx_quake.wav\",IDPRF_2D);",12);
  schedule("playSound(0,\"sfx_thunder1.wav\",IDPRF_2D);",12);
  schedule("setposition($ksatBeam,10000,10000,-10000);",14);
  schedule("$lastKSAT=\"\";",15); }
 else{ say(%player,%player,"<f4>.Masarmax JHovi is not receiving orders at this time."); } }

echo("ksat");

function vehicle::onDestroyed(%destroyed, %destroyer){
 vehicle::onDestroyedLog(%destroyed, %destroyer);
 %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
 if(%message != ""){ say( 0, 0, %message); }
 if($server::TeamPlay == true){ if((getTeam(%destroyed) == getTeam(%destroyer)) && (%destroyed != %destroyer)){ antiTeamKill(%destroyer); } }
 if(%destroyed.inbeamtrigger == true){
  $beamtrigger.active = $beamtrigger.active - 1;
  if($beamtrigger.active == 0){ setposition("MissionGroup\\weapon\\beam", 500, 2700, 10000); } }
 %destroyed.override = false;
 %destroyed.login = false;
 %destroyed.inbeamtrigger = false; }

echo("ondestroyed");

$killPoints = 2;
$deathPoints = 3;
$server::teamdamage = false;

function setRules(){
 if($server::TeamPlay == true){
  %rules = "<F5>Mission: <F2>S&S <F2>Black Ice<F0>.\n" @
           "<F5>Created by: <F2>Velax <F0>and <F2>www.SunAndShadows.com<F0> for AK servers.\n" @
           "<F5>Inspired by: <F0>The Tarazedi Alliance\n" @
           "<F5>Setting: <F0>Venga Linea Surface HQ, Europa.  10 June 2834.\n" @
           "<F5>Story: <F0>A massive weapon constructed in the upper atmosphere of Jupiter is constructed by the Tarazed " @
           "Alliance to clear the Cybrid presence on Io and Europa.  Unfortunately, the activation systems have fallen " @
           "under the influence of a virus and the login and command sequences have been re-enabled.\n" @
           "<F2>General map conditions:\n" @
           "<F5>Team Deathmatch: <F0>Kill opposing team.  Protect your teammates.  Defend your base and destroy opposing bases. Use map features to your advantage.\n" @
           "<F2>Special map conditions:\n" @
           "<F5>Masarmax JHovi: <F0>Vehicles may initiate a firing sequence by activating uplink systems."; }
 else{
  %rules = "<F5>Mission: <F2>S&S <F2>Black Ice<F0>.\n" @
           "<F5>Created by: <F2>Velax <F0>and <F2>www.SunAndShadows.com<F0> for AK servers.\n" @
           "<F5>Inspired by: <F0>The Tarazedi Alliance\n" @
           "<F5>Setting: <F0>Venga Linea Surface HQ, Europa.  10 June 2834.\n" @
           "<F5>Story: <F0>A massive weapon constructed in the upper atmosphere of Jupiter is constructed by the Tarazed " @
           "Alliance to clear the Cybrid presence on Io and Europa.  Unfortunately, the activation systems have fallen " @
           "under the influence of a virus and the login and command sequences have been re-enabled.\n" @
           "<F2>General map conditions:\n" @
           "<F5>Deathmatch: <F0>If it moves, kill it.  If it doesn't, kill it anyway..\n" @
           "<F2>Special map conditions:\n" @
           "<F5>Masarmax JHovi: <F0>Vehicles may initiate a firing sequence by activating uplink systems."; }
 setGameInfo(%rules); }

setRules();

function copyObject(%object,%name){
 storeObject(%object, "copyObject.tmp");
 if(%name==""){ %copy = loadObject(getObjectName(%object), "copyObject.tmp"); }
 else{ %copy = loadObject(%name, "copyObject.tmp"); }
 return %copy; }

function player::onAdd(%player){
 if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/")){
  say(0,0,"<f4>"@getname(%player)@" joined the game","alarm2.wav");
  messagebox(%player,"This server is equipped with an anti-stealth detection system. The slash on your name has been detected. All players have been alerted to your presence."); }
 say(%player, 0, "Welcome to S&S "@$missionname@" created by Velax.  Please read the rules carefully. Visit www.Sun and Shadows.com, your Starsiege community headquarters!"); }

function vehicle::onAdd(%this){
 if($server::TeamPlay != true){
  %player = playerManager::vehicleIdToPlayerNum(%this);
  if(%player == 0){ return; }
  setTeam(%this, *IDSTR_TEAM_YELLOW); }
 %player.hitstaken = 0;
 %player.hitsdealt = 0; }

function vehicle::onattacked(%v, %w){
 %player = playerManager::vehicleIdToPlayerNum(%v);
 %player2 = playerManager::vehicleIdToPlayerNum(%w);
 if(%player == %player2){ return; }
 if((getTeam(%player) == getTeam(%player2)) && ($server::teamplay == true)){ return; }
 %player.hitstaken++;
 %player2.hitsdealt++; }

function getPlayerScore(%a){ return((getKills(%a) * $killPoints) - (getDeaths(%a) * $deathPoints) + (%a.hitstaken / 50) + (%a.hitsdealt / 25)); }

function getTeamScore(%a){ return((getTeamKills(%a) * $killPoints) - (getTeamDeaths(%a) * $deathPoints)); }

function getHitsTaken(%a){ return(%a.hitsTaken); }

function getHitsDealt(%a){ return(%a.hitsDealt); }

function initScoreBoard(){
 deleteVariables("$ScoreBoard::PlayerColumn*");
 deleteVariables("$ScoreBoard::TeamColumn*");
 if($server::TeamPlay == "True"){
  $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_TEAM;
  $ScoreBoard::PlayerColumnHeader2 = "Score";
  $ScoreBoard::PlayerColumnHeader3 = "Hits Taken";
  $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_KILLS;
  $ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_DEATHS;
  $ScoreBoard::PlayerColumnHeader6 = "Hits Dealt";
  $ScoreBoard::PlayerColumnHeader7 = *IDMULT_SCORE_SQUAD;
  $ScoreBoard::PlayerColumnFunction1 = "getTeam";
  $ScoreBoard::PlayerColumnFunction2 = "getPlayerScore";
  $ScoreBoard::PlayerColumnFunction3 = "getHitsTaken";
  $ScoreBoard::PlayerColumnFunction4 = "getKills";
  $ScoreBoard::PlayerColumnFunction5 = "getDeaths";
  $ScoreBoard::PlayerColumnFunction6 = "getHitsDealt";
  $ScoreBoard::PlayerColumnFunction7 = "getSquad"; }
 else{
  $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_SQUAD;
  $ScoreBoard::PlayerColumnHeader2 = "Score";
  $ScoreBoard::PlayerColumnHeader3 = "Hits Taken";
  $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_KILLS;
  $ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_DEATHS;
  $ScoreBoard::PlayerColumnHeader6 = "Hits Dealt";
  $ScoreBoard::PlayerColumnFunction1 = "getSquad";
  $ScoreBoard::PlayerColumnFunction2 = "getPlayerScore";
  $ScoreBoard::PlayerColumnFunction3 = "getHitsTaken";
  $ScoreBoard::PlayerColumnFunction4 = "getKills";
  $ScoreBoard::PlayerColumnFunction5 = "getDeaths";
  $ScoreBoard::PlayerColumnFunction6 = "getHitsDealt"; }
 $ScoreBoard::TeamColumnHeader1 = *IDMULT_SCORE_SCORE;
 $ScoreBoard::TeamColumnHeader2 = *IDMULT_SCORE_PLAYERS;
 $ScoreBoard::TeamColumnHeader3 = *IDMULT_SCORE_KILLS;
 $ScoreBoard::TeamColumnHeader4 = *IDMULT_SCORE_DEATHS;
 $ScoreBoard::TeamColumnFunction1 = "getTeamScore";
 $ScoreBoard::TeamColumnFunction2 = "getNumberOfPlayersOnTeam";
 $ScoreBoard::TeamColumnFunction3 = "getTeamKills";
 $ScoreBoard::TeamColumnFunction4 = "getTeamDeaths";
 serverInitScoreBoard(); }
 
//
