// www.sunandshadows.com
// v1.0

$missionName = "Quicksilver";
exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
$server::HudMapViewOffsetX = 7000;
$server::HudMapViewOffsetY = 1000;

function setDefaultMissionOptions(){
 $server::TeamPlay = false;
 $server::AllowDeathmatch = true;
 $server::AllowTeamPlay = true;
 $server::AllowTeamRed = true;
 $server::AllowTeamBlue = true;
 $server::AllowTeamYellow = true;
 $server::AllowTeamPurple = true; }

function onMissionLoad(){ cdAudioCycle("SS3", "SS4", "SS3"); }

function outerplanetSounds(){
 meteorSounds();
 %weather1 = getObjectId("MissionGroup\\World\\sky");
 createAmbientSoundSource(%weather1, 0, 10, 50);
 addToAmbientSoundSource(%weather1, "sfx_quake.wav", IDPRF_2D); }
 
function onMissionStart(){
 $enableTeamHittingPenalty = true;
 outerplanetSounds(); }

function north::trigger::onenter(%this, %v){
 if(getteam(%v) != "Blue Team"){ setteam("Missiongroup\\turrets\\north", *IDSTR_TEAM_BLUE); }
 else{ setteam("Missiongroup\\turrets\\north", *IDSTR_TEAM_RED); }
 order("Missiongroup\\turrets\\north", attack, %v);
 say(0,0,"Nexus: Motion sensors transmitting coordinates.  Attacking target."); }

function south::trigger::onenter(%this, %v){
 if(getteam(%v) != "Blue Team"){ setteam("Missiongroup\\turrets\\south", *IDSTR_TEAM_BLUE); }
 else{ setteam("Missiongroup\\turrets\\south", *IDSTR_TEAM_RED); }
 order("Missiongroup\\turrets\\south", attack, %v);
 say(0,0,"Nexus: Motion sensors transmitting coordinates.  Attacking target."); }

function east::trigger::onenter(%this, %v){
 if(getteam(%v) != "Blue Team"){ setteam("Missiongroup\\turrets\\east", *IDSTR_TEAM_BLUE); }
 else{ setteam("Missiongroup\\turrets\\east", *IDSTR_TEAM_RED); }
 order("Missiongroup\\turrets\\east", attack, %v);
 say(0,0,"Nexus: Motion sensors transmitting coordinates.  Attacking target."); }

function west::trigger::onenter(%this, %v){
 if(getteam(%v) != "Blue Team"){ setteam("Missiongroup\\turrets\\west", *IDSTR_TEAM_BLUE); }
 else{ setteam("Missiongroup\\turrets\\west", *IDSTR_TEAM_RED); }
 order("Missiongroup\\turrets\\west", attack, %v);
 say(0,0,"Nexus: Motion sensors transmitting coordinates.  Attacking target."); }

function gate::trigger::onenter(%this, %v){
 if(getteam(%v) != "Blue Team"){ setteam("Missiongroup\\turrets\\gate", *IDSTR_TEAM_BLUE); }
 else{ setteam("Missiongroup\\turrets\\gate", *IDSTR_TEAM_RED); }
 order("Missiongroup\\turrets\\gate", attack, %v);
 say(0,0,"Nexus: Motion sensors transmitting coordinates.  Attacking target."); }

function motion0::structure::ondestroyed(%this, %v){
 healobject(%v, 1000);
 deleteobject("Missiongroup\\sensors\\trigger0"); }

function motion0::structure::ondestroyed(%this, %v){
 healobject(%v, 1000);
 deleteobject("Missiongroup\\sensors\\trigger1"); }

function motion2::structure::ondestroyed(%this, %v){
 healobject(%v, 1000);
 deleteobject("Missiongroup\\sensors\\trigger2"); }

function motion3::structure::ondestroyed(%this, %v){
 healobject(%v, 1000);
 deleteobject("Missiongroup\\sensors\\trigger3"); }

function motion4::structure::ondestroyed(%this, %v){
 healobject(%v, 1000);
 deleteobject("Missiongroup\\sensors\\trigger4"); }

function motion5::structure::ondestroyed(%this, %v){
 healobject(%v, 1000);
 deleteobject("Missiongroup\\sensors\\trigger5"); }

function motion6::structure::ondestroyed(%this, %v){
 healobject(%v, 1000);
 deleteobject("Missiongroup\\sensors\\trigger6"); }

function motion7::structure::ondestroyed(%this, %v){
 healobject(%v, 1000);
 deleteobject("Missiongroup\\sensors\\trigger7"); }

function motion8::structure::ondestroyed(%this, %v){
 healobject(%v, 1000);
 deleteobject("Missiongroup\\sensors\\trigger8"); }

function motion9::structure::ondestroyed(%this, %v){
 healobject(%v, 1000);
 deleteobject("Missiongroup\\sensors\\trigger9"); }

function motion10::structure::ondestroyed(%this, %v){
 healobject(%v, 1000);
 deleteobject("Missiongroup\\sensors\\trigger10"); }

function motion11::structure::ondestroyed(%this, %v){
 healobject(%v, 1000);
 deleteobject("Missiongroup\\sensors\\trigger11"); }

$killPoints = 2;
$deathPoints = 3;
$server::teamdamage = true;

function setRules(){
 if($server::TeamPlay == true){
  %rules = "<F5>Mission: <F2>S&S <F2>Quicksilver<F0>.\n" @
           "<F5>Created by: <F2>Velax <F0>and <F2>www.SunAndShadows.com<F0> for AK servers.\n" @
           "<F5>Inspired by: <F0>The Ghosts of the Antipode\n" @
           "<F5>Setting: <F0>Caloris region, Mercury.  10 November 2829.\n" @
           "<F5>Story: <F0>The last struggling survivors of the scattered TDF garrisons on Mercury scramble to control a " @
           "critical tactical asset... unfortunately the region is already the site of a Cybrid nexus.\n" @
           "<F2>General map conditions:\n" @
           "<F5>Team Deathmatch: <F0>Kill opposing team.  Protect your teammates.  Defend your base and destroy opposing bases. Use map features to your advantage.\n" @
           "<F2>Special map conditions:\n" @
           "<F5>Motion sensors: <F0>Cybrid motion sensors detect vehicles and direct the fire of turrets."; }
 else{
  %rules = "<F5>Mission: <F2>S&S <F2>Quicksilver<F0>.\n" @
           "<F5>Created by: <F2>Velax <F0>and <F2>www.SunAndShadows.com<F0> for AK servers.\n" @
           "<F5>Inspired by: <F0>The Ghosts of the Antipode\n" @
           "<F5>Setting: <F0>Caloris region, Mercury.  10 November 2829.\n" @
           "<F5>Story: <F0>The last struggling survivors of the scattered TDF garrisons on Mercury scramble to control a " @
           "critical tactical asset... unfortunately the region is already the site of a Cybrid nexus.\n" @
           "<F2>General map conditions:\n" @
           "<F5>Deathmatch: <F0>If it moves, kill it.  If it doesn't, kill it anyway..\n" @
           "<F2>Special map conditions:\n" @
           "<F5>Motion sensors: <F0>Cybrid motion sensors detect vehicles and direct the fire of turrets."; }
 setGameInfo(%rules); }

setRules();

function round(%n){
 %roundNum = %n;
 if(%n > 0){
  %excess = (%n - floor(%n));
  if(%excess >= 0.5){ %roundNum = (floor(%n) + 1); }
  else{ %roundNum = floor(%n); } }
 else if(%n < 0){
  %excess = (floor(%n) - %n);
  if(%excess <= 0.5){ %roundNum = floor(%n); }
  else{ %roundNum = (floor(%n) - 1); } }
 return %roundNum; }

function player::onAdd(%player){
 if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/")){
  say(0,0,"<f4>"@getname(%player)@" joined the game","alarm2.wav");
  messagebox(%player,"This server is equipped with an anti-stealth detection system. The slash on your name has been detected. All players have been alerted to your presence."); }
 say(%player, 0, "Welcome to S&S "@$missionname@" created by Velax.  Please read the rules carefully. Visit www.Sun and Shadows.com, your Starsiege community headquarters!"); }

function vehicle::onAdd(%this){
 if($server::TeamPlay != true){
  %player = playerManager::vehicleIdToPlayerNum(%this);
  if(%player == 0){ return; }
  setTeam(%this, *IDSTR_TEAM_YELLOW); }
 %player.hitstaken = 0;
 %player.hitsdealt = 0; }

function vehicle::onattacked(%v, %w){
 %player = playerManager::vehicleIdToPlayerNum(%v);
 %player2 = playerManager::vehicleIdToPlayerNum(%w);
 if(%player == %player2){ return; }
 if((getTeam(%player) == getTeam(%player2)) && ($server::teamplay == true)){ return; }
 %player.hitstaken++;
 %player2.hitsdealt++; }

function getPlayerScore(%a){ return((getKills(%a) * $killPoints) - (getDeaths(%a) * $deathPoints) + (%a.hitstaken / 50) + (%a.hitsdealt / 25)); }

function getTeamScore(%a){ return((getTeamKills(%a) * $killPoints) - (getTeamDeaths(%a) * $deathPoints)); }

function getHitsTaken(%a){ return(%a.hitsTaken); }

function getHitsDealt(%a){ return(%a.hitsDealt); }

function initScoreBoard(){
 deleteVariables("$ScoreBoard::PlayerColumn*");
 deleteVariables("$ScoreBoard::TeamColumn*");
 if($server::TeamPlay == "True"){
  $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_TEAM;
  $ScoreBoard::PlayerColumnHeader2 = "Score";
  $ScoreBoard::PlayerColumnHeader3 = "Hits Taken";
  $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_KILLS;
  $ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_DEATHS;
  $ScoreBoard::PlayerColumnHeader6 = "Hits Dealt";
  $ScoreBoard::PlayerColumnHeader7 = *IDMULT_SCORE_SQUAD;
  $ScoreBoard::PlayerColumnFunction1 = "getTeam";
  $ScoreBoard::PlayerColumnFunction2 = "getPlayerScore";
  $ScoreBoard::PlayerColumnFunction3 = "getHitsTaken";
  $ScoreBoard::PlayerColumnFunction4 = "getKills";
  $ScoreBoard::PlayerColumnFunction5 = "getDeaths";
  $ScoreBoard::PlayerColumnFunction6 = "getHitsDealt";
  $ScoreBoard::PlayerColumnFunction7 = "getSquad"; }
 else{
  $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_SQUAD;
  $ScoreBoard::PlayerColumnHeader2 = "Score";
  $ScoreBoard::PlayerColumnHeader3 = "Hits Taken";
  $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_KILLS;
  $ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_DEATHS;
  $ScoreBoard::PlayerColumnHeader6 = "Hits Dealt";
  $ScoreBoard::PlayerColumnFunction1 = "getSquad";
  $ScoreBoard::PlayerColumnFunction2 = "getPlayerScore";
  $ScoreBoard::PlayerColumnFunction3 = "getHitsTaken";
  $ScoreBoard::PlayerColumnFunction4 = "getKills";
  $ScoreBoard::PlayerColumnFunction5 = "getDeaths";
  $ScoreBoard::PlayerColumnFunction6 = "getHitsDealt"; }
 $ScoreBoard::TeamColumnHeader1 = *IDMULT_SCORE_SCORE;
 $ScoreBoard::TeamColumnHeader2 = *IDMULT_SCORE_PLAYERS;
 $ScoreBoard::TeamColumnHeader3 = *IDMULT_SCORE_KILLS;
 $ScoreBoard::TeamColumnHeader4 = *IDMULT_SCORE_DEATHS;
 $ScoreBoard::TeamColumnFunction1 = "getTeamScore";
 $ScoreBoard::TeamColumnFunction2 = "getNumberOfPlayersOnTeam";
 $ScoreBoard::TeamColumnFunction3 = "getTeamKills";
 $ScoreBoard::TeamColumnFunction4 = "getTeamDeaths";
 serverInitScoreBoard(); }
//
