// www.sunandshadows.com
// v1.0

$missionName = "Ares and Hades";
exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
$server::HudMapViewOffsetX = 1000;
$server::HudMapViewOffsetY = 2000;

Pilot Police{
 name = "Imperial Police";
 id = 30;
 skill = 2;
 accuracy = 2;
 aggressiveness = 2;
 activateDist = 10;
 deactivateBuff = 100;
 targetFreq = 1;
 trackFreq = 0.1;
 fireFreq = 0.3;
 LOSFreq = 0.1; };

function setDefaultMissionOptions(){
 $server::TeamPlay = false;
 $server::AllowDeathmatch = true;
 $server::AllowTeamPlay = true;
 $server::AllowTeamRed = true;
 $server::AllowTeamBlue = true;
 $server::AllowTeamYellow = true;
 $server::AllowTeamPurple = true; }

function onMissionLoad(){ cdAudioCycle("SS3", "SS4", "SS3"); }

function onMissionStart(){
 storeobject("Missiongroup\\ai\\policetalon", "policetalon.gse");
 $turretteam = *IDSTR_TEAM_NEUTRAL;
 $turretsensor = true;
 $police = 2;
 marsSounds(); }

function police::vehicle::onadd(%v){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){
  damageobject(%v, 1000000);
  say(0,0,"<F5>Player "@getName(%player)@" attempted to spawn in a scripted vehicle!");
  return; }
 setpilotid(%v, 30); }

function police::vehicle::ondestroyed(%v){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){
  damageobject(%v, 1000000);
  return; }
 %random = randomInt(1,3);
 if(%random == 1){ say(0, 0, "<F4>Police Headquarters: Dustrats took out one of the guards.  No mercy!"); }
 else if(%random == 2){ say(0, 0, "<F4>Police Headquarters: One of the guards is vaped!  Call reinforcements!"); }
 else if(%random == 3){ say(0, 0, "<F4>Police Headquarters: Kill the dustscum!"); }
 if( $police <= 9 ){
  spawnCop();
  spawnCop(); }
 else{ spawncop(); } }

function spawnCop(){
 %this = loadobject("talon", "policetalon.gse");
 setposition(%this, 2000, 4000 + randomint(-200,200), 2000);
 setteam(%this, $turretteam);
 order(%this, guard, "MissionGroup\\blueBase\\sensor");
 $police++; }

function vehicle::onSpot(%spotter,%target){
 %player = playermanager::vehicleIdtoPlayerNum(%spotter);
 %player2 = playermanager::vehicleIdtoPlayerNum(%target);
 if( getTeam(%spotter) != $turretteam ){
  say(%player,%player,"<f4>Your team does not have turret access.","alarm2.wav");
  return; }
 if( $turretsensor == false ){
  say(%player,%player,"<f4>Turret control systems are offline.","alarm2.wav");
  return; }
 if(%target!=""){
  if((getTeam(%spotter)==getTeam(%target))&&($server::teamplay==true)){
   say(%player,%player,"<f4>You cannot spot your teammates.","alarm2.wav"); }
  else{
   order("MissionGroup/Turrets", attack, %target);
   say(%player,%player,"<f4>Your turrets have been ordered to attack "@getHudName(%target)@"."); }
   if(%player2 != 0){ say(%player2, %player2, "<F0>Warning!  "@getHudName(%spotter)@" <F5>has targeted turret control on you!"); } }
 else{
   order("MissionGroup/Turrets", attack, 0);
   order("MissionGroup/Turrets", clear);
   say(%player,%player,"<f4>Target lost. You must maintain target lock."); } }

function turret1::structure::onscan(%v, %w){
 %team = getTeam(%w);
 setteam(%v, %team);
 healobject(%v, 10000);
 reloadobject(%v, 10000);
 setteam("Missiongroup\\Turrets\\1", %team); }

function turret2::structure::onscan(%v, %w){
 %team = getTeam(%w);
 setteam(%v, %team);
 healobject(%v, 10000);
 reloadobject(%v, 10000);
 setteam("Missiongroup\\Turrets\\2", %team); }

function turret3::structure::onscan(%v, %w){
 %team = getTeam(%w);
 setteam(%v, %team);
 healobject(%v, 10000);
 reloadobject(%v, 10000);
 setteam("Missiongroup\\Turrets\\3", %team); }

function turret4::structure::onscan(%v, %w){
 %team = getTeam(%w);
 setteam(%v, %team);
 healobject(%v, 10000);
 reloadobject(%v, 10000);
 setteam("Missiongroup\\Turrets\\4", %team); }
 
function turret5::structure::onscan(%v, %w){
 %team = getTeam(%w);
 setteam(%v, %team);
 healobject(%v, 10000);
 reloadobject(%v, 10000);
 setteam("Missiongroup\\Turrets\\5", %team); }

function defense::structure::onscan(%v, %w){
 if($turretteam == getTeam(%w)){ return; }
 %w.hitsdealt = %w.hitsdealt + 100;
 $turretteam = getTeam(%w);
 setteam("Missiongroup\\Turrets\\1", $turretteam);
 setteam("Missiongroup\\Turrets\\2", $turretteam);
 setteam("Missiongroup\\Turrets\\3", $turretteam);
 setteam("Missiongroup\\Turrets\\4", $turretteam);
 setteam("Missiongroup\\Turrets\\5", $turretteam);
 setteam(%v, $turretteam);
 setteam("Missiongroup\\bluebase\\sensor", $turretteam);
 setteam("Missiongroup\\redbase\\reactor", $turretteam);
 setteam("Missiongroup\\ai\\policetalon", $turretteam);
 setteam("Missiongroup\\ai\\2", $turretteam);
 order("MissionGroup/ai", guard, %w);
 say(0,0,"Turrets set to "@$turretteam@"."); }

function sensor::structure::ondestroyed(%v){ $turretsensor = false; }

function reactor::structure::onDestroyed(%t){
 %random = randomInt(1,3);
 if(%random == 1){ say(0, 0, "<F4>Police Headquarters: Dustrats took out the reactor!"); }
 else if(%random == 2){ say(0, 0, "<F4>Police Headquarters: Power's gone, sector one!"); }
 else if(%random == 3){ say(0, 0, "<F4>Police Headquarters: Turrets are offline, systems crashing!"); }
 order("Missiongroup\\Turrets\\1", shutdown, true);
 order("Missiongroup\\Turrets\\2", shutdown, true);
 order("Missiongroup\\Turrets\\3", shutdown, true);
 order("Missiongroup\\Turrets\\4", shutdown, true);
 setteam("Missiongroup/Turrets", *IDSTR_TEAM_NEUTRAL);
 damageArea(%t,0,0,0,1000,4000); }

function atmosphere::structure::onDestroyed(%t){
 damageObject("Missiongroup/easteregg", 100000000 );
 damageArea(%t,0,0,0,1000,10000); }

function boom::structure::onDestroyed(%t){ damageArea(%t,0,0,0,300,2000); }

function bigboom::structure::onDestroyed(%t){ damageArea(%t,0,0,0,1000,4000); }

$killPoints = 2;
$deathPoints = 3;
$server::teamdamage = true;

function setRules(){
 if($server::TeamPlay == true){
  %rules = "<F5>Mission: <F2>S&S <F2>Ares and Hades<F0>.\n" @
           "<F5>Created by: <F2>Velax <F0>and <F2>www.SunAndShadows.com<F0> for AK servers.\n" @
           "<F5>Setting: <F0>Agricultural commune, Mars. 03 September 2827.\n" @
           "<F5>Story: <F0>The Police rule this lawless frontier town with an iron fist and turrets ready to kill at the touch of a button.\n" @
           "<F2>General map conditions:\n" @
           "<F5>Team Deathmatch: <F0>Kill opposing team.  Protect your teammates.  Defend your base and destroy opposing bases. Use map features to your advantage.\n" @
           "<F2>Special map conditions:\n" @
           "<F5>Police: <F0>The Imperial Police maintain turrets in the area to attack unruly dustrats. " @
           "These turrets may be captured by scanning the defense tower, and disabled by destroying certain structures. "@
           "An LTADS will allow you to spot vehicles to destroy. \n" @
           "<F5>Explosives: <F0>Power stations and tankers may detonate violently when destroyed.\n" @
           "<F5>Patrols: <F0>Police vehicles patrol the facility.\n" @
           "<F5>Repairs: <F0>All bases are equipped with reload facilities.  Police HQ also has a repair center."; }
 else{
  %rules = "<F5>Mission: <F2>S&S <F2>Ares and Hades<F0>.\n" @
           "<F5>Created by: <F2>Velax <F0>and <F2>www.SunAndShadows.com<F0> for AK servers.\n" @
           "<F5>Setting: <F0>Agricultural commune, Mars. 03 September 2827.\n" @
           "<F5>Story: <F0>The Police rule this lawless frontier town with an iron fist and turrets ready to kill at the touch of a button.\n" @
           "<F2>General map conditions:\n" @
           "<F5>Deathmatch: <F0>If it moves, kill it.  If it doesn't, kill it anyway..\n" @
           "<F2>Special map conditions:\n" @
           "<F5>Police: <F0>The Imperial Police maintain turrets in the area to attack unruly dustrats. " @
           "These turrets may be captured by scanning the defense tower, and disabled by destroying certain structures. "@
           "An LTADS will allow you to spot vehicles to destroy. \n" @
           "<F5>Explosives: <F0>Power stations and tankers may detonate violently when destroyed.\n" @
           "<F5>Patrols: <F0>Police vehicles patrol the facility.\n" @
           "<F5>Repairs: <F0>All bases are equipped with reload facilities.  Police HQ also has a repair center."; }
 setGameInfo(%rules); }

setRules();

function player::onAdd(%player){
 if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/")){
  say(0,0,"<f4>"@getname(%player)@" joined the game","alarm2.wav");
  messagebox(%player,"This server is equipped with an anti-stealth detection system. The slash on your name has been detected. All players have been alerted to your presence."); }
 say(%player, 0, "Welcome to S&S "@$missionname@" created by Velax.  Please read the rules carefully. Visit www.Sun and Shadows.com, your Starsiege community headquarters!"); }

function vehicle::onAdd(%this){
 if($server::TeamPlay != true){
  %player = playerManager::vehicleIdToPlayerNum(%this);
  if(%player == 0){ return; }
  setTeam(%this, *IDSTR_TEAM_YELLOW); }
 %player.hitstaken = 0;
 %player.hitsdealt = 0; }

function vehicle::onattacked(%v, %w){
 %player = playerManager::vehicleIdToPlayerNum(%v);
 %player2 = playerManager::vehicleIdToPlayerNum(%w);
 if(%player == %player2){ return; }
 if((getTeam(%player) == getTeam(%player2)) && ($server::teamplay == true)){ return; }
 %player.hitstaken++;
 %player2.hitsdealt++; }

function getPlayerScore(%a){ return((getKills(%a) * $killPoints) - (getDeaths(%a) * $deathPoints) + (%a.hitstaken / 50) + (%a.hitsdealt / 25)); }

function getTeamScore(%a){ return((getTeamKills(%a) * $killPoints) - (getTeamDeaths(%a) * $deathPoints)); }

function getHitsTaken(%a){ return(%a.hitsTaken); }

function getHitsDealt(%a){ return(%a.hitsDealt); }

function initScoreBoard(){
 deleteVariables("$ScoreBoard::PlayerColumn*");
 deleteVariables("$ScoreBoard::TeamColumn*");
 if($server::TeamPlay == "True"){
  $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_TEAM;
  $ScoreBoard::PlayerColumnHeader2 = "Score";
  $ScoreBoard::PlayerColumnHeader3 = "Hits Taken";
  $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_KILLS;
  $ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_DEATHS;
  $ScoreBoard::PlayerColumnHeader6 = "Hits Dealt";
  $ScoreBoard::PlayerColumnHeader7 = *IDMULT_SCORE_SQUAD;
  $ScoreBoard::PlayerColumnFunction1 = "getTeam";
  $ScoreBoard::PlayerColumnFunction2 = "getPlayerScore";
  $ScoreBoard::PlayerColumnFunction3 = "getHitsTaken";
  $ScoreBoard::PlayerColumnFunction4 = "getKills";
  $ScoreBoard::PlayerColumnFunction5 = "getDeaths";
  $ScoreBoard::PlayerColumnFunction6 = "getHitsDealt";
  $ScoreBoard::PlayerColumnFunction7 = "getSquad"; }
 else{
  $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_SQUAD;
  $ScoreBoard::PlayerColumnHeader2 = "Score";
  $ScoreBoard::PlayerColumnHeader3 = "Hits Taken";
  $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_KILLS;
  $ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_DEATHS;
  $ScoreBoard::PlayerColumnHeader6 = "Hits Dealt";
  $ScoreBoard::PlayerColumnFunction1 = "getSquad";
  $ScoreBoard::PlayerColumnFunction2 = "getPlayerScore";
  $ScoreBoard::PlayerColumnFunction3 = "getHitsTaken";
  $ScoreBoard::PlayerColumnFunction4 = "getKills";
  $ScoreBoard::PlayerColumnFunction5 = "getDeaths";
  $ScoreBoard::PlayerColumnFunction6 = "getHitsDealt"; }
 $ScoreBoard::TeamColumnHeader1 = *IDMULT_SCORE_SCORE;
 $ScoreBoard::TeamColumnHeader2 = *IDMULT_SCORE_PLAYERS;
 $ScoreBoard::TeamColumnHeader3 = *IDMULT_SCORE_KILLS;
 $ScoreBoard::TeamColumnHeader4 = *IDMULT_SCORE_DEATHS;
 $ScoreBoard::TeamColumnFunction1 = "getTeamScore";
 $ScoreBoard::TeamColumnFunction2 = "getNumberOfPlayersOnTeam";
 $ScoreBoard::TeamColumnFunction3 = "getTeamKills";
 $ScoreBoard::TeamColumnFunction4 = "getTeamDeaths";
 serverInitScoreBoard(); }

//
