// www.sunandshadows.com
// v1.0

$missionName = "Check Your Seals";
exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
$server::HudMapViewOffsetX = 1000;
$server::HudMapViewOffsetY = 3000;

Pilot Caravaneer{
 name = "Loki Caravaneer";
 id = 30;
 skill = 1;
 accuracy = 2;
 aggressiveness = 2;
 activateDist = 10;
 deactivateBuff = 100;
 targetFreq = 1;
 trackFreq = 0.1;
 fireFreq = 0.3;
 LOSFreq = 0.1; };

Pilot Caravaneer2{
 name = "Bearhunter Caravaneer";
 id = 29;
 skill = 2;
 accuracy = 1;
 aggressiveness = 2;
 activateDist = 10;
 deactivateBuff = 100;
 targetFreq = 1;
 trackFreq = 0.1;
 fireFreq = 0.3;
 LOSFreq = 0.1; };

function setDefaultMissionOptions(){
 $server::TeamPlay = false;
 $server::AllowDeathmatch = true;
 $server::AllowTeamPlay = true;
 $server::AllowTeamRed = true;
 $server::AllowTeamBlue = true;
 $server::AllowTeamYellow = true;
 $server::AllowTeamPurple = true; }

newFormation(Follow, 0,   0,0,
                     0, -40,0,
                     0, -80,0,
                     0,-120,0,
                     0,-160,0,
                     0,-200,0,
                     0,-240,0,
                     0,-280,0 );
function onMissionLoad(){ cdAudioCycle("SS3", "SS4", "SS3"); }

function onMissionStart(){
 order("MissionGroup\\redlead", guard, "MissionGroup/veenpath");
 setpilotid("MissionGroup\\redlead",30);
 setpilotid("MissionGroup/redbase",30);
 order("MissionGroup\\redbase\\1", guard, "MissionGroup\\redlead");
 order("MissionGroup\\redbase\\2", guard, "MissionGroup\\redbase\\1");
 order("MissionGroup\\redbase\\3", guard, "MissionGroup\\redbase\\2");
 order("MissionGroup\\redbase\\redheal1", guard, "MissionGroup\\redbase\\3");
 order("MissionGroup\\redbase\\redheal2", guard, "MissionGroup\\redbase\\redheal1");
 order("MissionGroup\\redbase\\redattack", guard, "MissionGroup/veenpath");
 order("MissionGroup\\redlead", speed, low);
 order("MissionGroup/redbase", speed, low);
 order("MissionGroup\\yellowlead", guard, "MissionGroup/veenpath");
 setpilotid("MissionGroup\\yellowlead",30);
 setpilotid("MissionGroup/yellowbase",30);
 order("MissionGroup\\yellowbase\\1", guard, "MissionGroup\\yellowlead");
 order("MissionGroup\\yellowbase\\2", guard, "MissionGroup\\yellowbase\\1");
 order("MissionGroup\\yellowbase\\3", guard, "MissionGroup\\yellowbase\\2");
 order("MissionGroup\\yellowbase\\yellowheal1", guard, "MissionGroup\\yellowbase\\3");
 order("MissionGroup\\yellowbase\\yellowheal2", guard, "MissionGroup\\yellowbase\\yellowheal1");
 order("MissionGroup\\yellowbase\\yellowattack", guard, "MissionGroup/veenpath");
 order("MissionGroup\\yellowlead", speed, low);
 order("MissionGroup/yellowbase", speed, low);
 $redattack = getobjectid("MissionGroup\\redbase\\redattack");
 $yellowattack = getobjectid("MissionGroup\\yellowbase\\yellowattack");
 storeobject("MissionGroup\\redbase\\redattack", "redavenger.gse");
 storeobject("MissionGroup\\yellowbase\\yellowattack", "yellowavenger.gse");
 storeobject("MissionGroup\\redbase\\redheal1", "redheal.gse");
 storeobject("MissionGroup\\yellowbase\\yellowheal1", "yellowheal.gse");
 $dpn = 0;
 schedule("refreshCaravans();", 10);
 venusSounds(); }

function redHeal::vehicle::onadd(%v){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){
  damageobject(%v, 1000000);
  say(0,0,"<F5>Player "@getName(%player)@" attempted to spawn in a scripted vehicle!");
  return; } }

function yellowHeal::vehicle::onadd(%v){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){
  damageobject(%v, 1000000);
  say(0,0,"<F5>Player "@getName(%player)@" attempted to spawn in a scripted vehicle!");
  return; } }

function redVeen::vehicle::onadd(%v){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){
  damageobject(%v, 1000000);
  say(0,0,"<F5>Player "@getName(%player)@" attempted to spawn in a scripted vehicle!");
  return; } }

function yellowVeen::vehicle::onadd(%v){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){
  damageobject(%v, 1000000);
  say(0,0,"<F5>Player "@getName(%player)@" attempted to spawn in a scripted vehicle!");
  return; } }

function redHeal::vehicle::ondestroyed(%v){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){ return; }
 %random = randomInt(1,3);
 $redsplit = true;
 if(%random == 1){ say(IDSTR_TEAM_RED, 0, "<F4>Loki Headguide: Caveen, check seals!  They took one of us out.  Form on the guards!"); }
 else if(%random == 2){ say(IDSTR_TEAM_RED, 0, "<F4>Loki Headguide: All chitons, check seals!  Scatter and wait!"); }
 else if(%random == 3){ say(IDSTR_TEAM_RED, 0, "<F4>Loki Headguide: Calling reinforcements, look to the guards!"); }
 order("MissionGroup\\redbase\\redheal1", guard, "MissionGroup\\redbase\\3");
 order("MissionGroup\\redbase\\redheal2", guard, "MissionGroup\\redbase\\3");
 %this = loadobject("heal", "redheal.gse");
 setposition(%this, 2000, 4000 + randomint(-200,200), 2000);
 order(%this, guard, $redattack); }

function yellowHeal::vehicle::ondestroyed(%v){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){ return; }
 %random = randomInt(1,3);
 $yellowsplit = true;
 if(%random == 1){ say(IDSTR_TEAM_YELLOW, 0, "<F4>Bearhunter Headguide: Caveen, check seals!  They took one of us out.  Split up!"); }
 else if(%random == 2){ say(IDSTR_TEAM_YELLOW, 0, "<F4>Bearhunter Headguide: Condition red, execute pattern beta!"); }
 else if(%random == 3){ say(IDSTR_TEAM_YELLOW, 0, "<F4>Bearhunter Headguide: Reinforcements inbound, execute guard sequence."); }
 order("MissionGroup\\yellowbase\\yellowheal1", guard, "MissionGroup\\yellowbase\\3");
 order("MissionGroup\\yellowbase\\yellowheal2", guard, "MissionGroup\\yellowbase\\3");
 %this = loadobject("heal", "yellowheal.gse");
 setposition(%this, 0, 4000 + randomint(-200,200), 2000);
 order(%this, guard, $yellowattack);  }

function randomDrop(%this){
 %player = playerManager::vehicleIdToPlayerNum(%this);
 fadeEvent(%player, in, 20, 3, 3, 3 );
 setPosition(%this, 0, 4000, 8000);
 %endX = randomInt(-1000, -1000);
 %endY = randomInt(3000, 5000);
 %endZ = getTerrainHeight(%endX, %endY);
 dropPod(0, 4000, 1000, %endX, %endY, %endZ, %this); }

function redveen::vehicle::ondestroyed(%v, %w){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){ return; }
 if(%v != $redattack){ return; }
 $redattack = loadobject("redattack", "redavenger.gse");
 reloadobject(%w, 1000);
 setposition($redattack, 2000 + randomint(-200,200), 4000, 2000); }

function yellowveen::vehicle::ondestroyed(%v, %w){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){ return; }
 if(%v != $yellowattack){ return; }
 $yellowattack = loadobject("yellowattack", "yellowavenger.gse");
 reloadobject(%w, 1000);
 setposition($yellowattack, 0 + randomint(-200,200), 4000, 2000); }

function redveen::vehicle::onattacked(%v, %w){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){ return; }
 healobject(%v, 1000);
 order($redattack, attack, %w); }

function redheal::vehicle::onattacked(%v, %w){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){ return; }
 healobject(%v, 5000);
 order($redattack, attack, %w); }

function yellowveen::vehicle::onattacked(%v, %w){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){ return; }
 healobject(%v, 1000);
 order($yellowattack, attack, %w); }

function yellowheal::vehicle::onattacked(%v, %w){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){ return; }
 healobject(%v, 5000);
 order($redattack, attack, %w); }

function refreshCaravans(){
 order($redattack, guard, "MissionGroup/veenpath");
 order($yellowattack, guard, "MissionGroup/veenpath");
 reloadobject($redattack, 100000);
 reloadobject($yellowattack, 100000);
 $dpn++;
 if($dpn == 10){ $dpn = 0; }
 $x = getPosition("MissionGroup\\redlead", x);
 $y = getPosition("MissionGroup\\redlead", y);
 $z = getPosition("MissionGroup\\redlead", z);
 $v = getDistance("MissionGroup\\navs\\rednav", "MissionGroup\\redlead");
 $v = $v / 10 * 3.6;
 setPosition("MissionGroup\\navs\\rednav", $x, $y, $z);
 setPosition("MissionGroup\\dropPointGroup3\\droppoint"@$dpn, $x + 10, $y + 10, $z + 20);
 $a = getPosition("MissionGroup\\yellowlead", x);
 $b = getPosition("MissionGroup\\yellowlead", y);
 $c = getPosition("MissionGroup\\yellowlead", z);
 $w = getDistance("MissionGroup\\navs\\yellownav", "MissionGroup\\yellowlead");
 $w = $w / 10 * 3.6;
 setPosition("MissionGroup\\navs\\yellownav", $a, $b, $c);
 setPosition("MissionGroup\\dropPointGroup1\\droppoint"@$dpn, $a + 10, $b + 10, $c + 20);
 schedule("refreshCaravans();", 10);
 $r = "<F4>Loki Caravan position: <F5>"@round($x)@" <F4>x, <F5>"@round($y)@" <F4>y, <F5>"@round($z)@" <F4>z. <F5>"@round($v)@" <F4>kph.\n"
    @ "<F4>Bearhunter Caravan position: <F5>"@round($a)@" <F4>x, <F5>"@round($b)@" <F4>y, <F5>"@round($c)@" <F4>z. <F5>"@round($w)@" <F4>kph.\n";
 if($dpn == 1){ say(0,0,$r); } }

function redHeal::vehicle::onScan(%t, %v){
 %player = playerManager::vehicleIdToPlayerNum(%v);
 if(getTeam(%v) != *IDSTR_TEAM_RED && $server::teamplay == true){
  %random = randomInt(1,3);
  if(%random == 1){ say(%player, 0, "<F4>Caravaneer: Wrong Caravan buddy.  Piss off."); }
  else if(%random == 2){ say(%player, 0, "<F4>Caravaneer: Repair? How about I shove a scorchin' spanner down your throat?"); }
  else if(%random == 3){ say(%player, 0, "<F4>Caravaneer: We serve our own.  Not your kind."); }
  damageObject( %v, 2000 );
  return; }
 if(%t.healing == true){
  %random = randomInt(1,3);
  if(%random == 1){ say(%player, 0, "<F4>Caravaneer: I'm gettin' it ready for ya boss.  Hang tight."); }
  else if(%random == 2){ say(%player, 0, "<F4>Caravaneer: What you think this is, Ishtar?  Hold your scarabs."); }
  else if(%random == 3){ say(%player, 0, "<F4>Caravaneer: Workin', workin', boss.  Scorch off until I say."); }
  return; }
 if(isShutDown(%v) != true){
  %random = randomInt(1,3);
  if(%random == 1){ say(%player, 0, "<F4>Caravaneer: Ya wanna hold still a minute?"); }
  else if(%random == 2){ say(%player, 0, "<F4>Caravaneer: I'm not gonna chase you around boss."); }
  else if(%random == 3){ say(%player, 0, "<F4>Caravaneer: Sit your butt down if you want fixed."); }
  return; }
 %t.healing = true;
 order(%t, shutdown, true);
 %random = randomInt(1,3);
 if(%random == 1){ say(%player, 0, "<F4>Caravaneer: Yea, fixing you up boss."); }
 else if(%random == 2){ say(%player, 0, "<F4>Caravaneer: Stop getting scorched.  Metal's not cheap."); }
 else if(%random == 3){ say(%player, 0, "<F4>Caravaneer: Roj boss, repairs underway."); }
 healLoopUntilPowerup(%t, %v);
 schedule("readyForNextCustomer("@%t@");", 60); }

function yellowHeal::vehicle::onScan(%t, %v){
 %player = playerManager::vehicleIdToPlayerNum(%v);
 if(getTeam(%v) != *IDSTR_TEAM_YELLOW && $server::teamplay == true){
  %random = randomInt(1,3);
  if(%random == 1){ say(%player, 0, "<F4>Caravaneer: Wrong Caravan buddy.  Piss off."); }
  else if(%random == 2){ say(%player, 0, "<F4>Caravaneer: Repair? How about I shove a scorchin' spanner down your throat?"); }
  else if(%random == 3){ say(%player, 0, "<F4>Caravaneer: We serve our own.  Not your kind."); }
  damageObject( %v, 2000 );
  return; }
 if(%t.healing == true){
  %random = randomInt(1,3);
  if(%random == 1){ say(%player, 0, "<F4>Caravaneer: I'm gettin' it ready for ya boss.  Hang tight."); }
  else if(%random == 2){ say(%player, 0, "<F4>Caravaneer: What you think this is, Ishtar?  Hold your scarabs."); }
  else if(%random == 3){ say(%player, 0, "<F4>Caravaneer: Workin', workin', boss.  Scorch off until I say."); }
  return; }
 if(isShutDown(%v) != true){
  %random = randomInt(1,3);
  if(%random == 1){ say(%player, 0, "<F4>Caravaneer: Ya wanna hold still a minute?"); }
  else if(%random == 2){ say(%player, 0, "<F4>Caravaneer: I'm not gonna chase you around boss."); }
  else if(%random == 3){ say(%player, 0, "<F4>Caravaneer: Sit your butt down if you want fixed."); }
  return; }
 %t.healing = true;
 order(%t, shutdown, true);
 %random = randomInt(1,3);
 if(%random == 1){ say(%player, 0, "<F4>Caravaneer: Yea, fixing you up boss."); }
 else if(%random == 2){ say(%player, 0, "<F4>Caravaneer: Stop getting scorched.  Metal's not cheap."); }
 else if(%random == 3){ say(%player, 0, "<F4>Caravaneer: Roj boss, repairs underway."); }
 healLoopUntilPowerup(%t, %v);
 schedule("readyForNextCustomer("@%t@");", 60); }

function readyForNextCustomer(%t){
 echo(%t@" is ready to rokk.");
 %t.healing = false;
 order(%t, shutdown, false); }
 
function healLoopUntilPowerup(%t, %v){
 if(isShutDown(%t) == false){ return; }
 if(isShutDown(%v) == false){ return; }
 healObject(%v, 1000);
 echo(%t@" is healing "@%v@".");
 schedule("healLoopUntilPowerUp("@%t@","@%v@");", 7); }

$killPoints = 2;
$deathPoints = 3;
$server::teamdamage = false;

function setRules(){
 if($server::TeamPlay == true){
  %rules = "<F5>Mission: <F2>S&S <F2>Check Your Seals<F0>.\n" @
           "<F5>Created by: <F2>Velax <F0>and <F2>www.SunAndShadows.com<F0> for AK servers.\n" @
           "<F5>Inspired by: <F0>'Blood Sky' by Timeless.\n" @
           "<F5>Setting: <F0>Venusian Caravan facility. 03 August 2830.\n" @
           "<F5>Story: <F0>Warring caravans roam the countryside searching for mining spots, while a Cybrid force penetrates the Oberwind...\n" @
           "<F2>General map conditions:\n" @
           "<F5>Team Deathmatch: <F0>Kill opposing team.  Protect your teammates.  Defend your base and destroy opposing bases. Use map features to your advantage.\n" @
           "<F2>Special map conditions:\n" @
           "<F5>Droppods: <F0>Cybrid vehicles drop in pods instead of bases.\n" @
           "<F5>Caravans: <F0>Red and yellow bases are mobile.\n" @
           "<F5>Patrols: <F0>Elite Caravaneer scouts patrol and protect.\n" @
           "<F5>Caravan Repairs: <F0>Utility trucks await to serve Caravaneers.  Purple and Blue bases have heal pads but no reload facilities are available."; }
 else{
  %rules = "<F5>Mission: <F2>S&S <F2>Check Your Seals<F0>.\n" @
           "<F5>Created by: <F2>Velax <F0>and <F2>www.SunAndShadows.com<F0> for AK servers.\n" @
           "<F5>Inspired by: <F0>'Blood Sky' by Timeless.\n" @
           "<F5>Setting: <F0>Venusian Caravan facility. 03 August 2830.\n" @
           "<F5>Story: <F0>Warring caravans roam the countryside searching for mining spots, while a Cybrid force penetrates the Oberwind...\n" @
           "<F2>General map conditions:\n" @
           "<F5>Deathmatch: <F0>If it moves, kill it.  If it doesn't, kill it anyway..\n" @
           "<F2>Special map conditions:\n" @
           "<F5>Droppods: <F0>Cybrid vehicles drop in pods instead of bases.\n" @
           "<F5>Caravans: <F0>Red and yellow bases are mobile.\n" @
           "<F5>Patrols: <F0>Elite Caravaneer scouts patrol and protect.\n" @
           "<F5>Caravan Repairs: <F0>Utility trucks await to serve Caravaneers.  Purple and Blue bases have heal pads but no reload facilities are available."; }
 setGameInfo(%rules); }

setRules();

function round(%n){
 %roundNum = %n;
 if(%n > 0){
  %excess = (%n - floor(%n));
  if(%excess >= 0.5){ %roundNum = (floor(%n) + 1); }
  else{ %roundNum = floor(%n); } }
 else if(%n < 0){
  %excess = (floor(%n) - %n);
  if(%excess <= 0.5){ %roundNum = floor(%n); }
  else{ %roundNum = (floor(%n) - 1); } }
 return %roundNum; }

function player::onAdd(%player){
 if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/")){
  say(0,0,"<f4>"@getname(%player)@" joined the game","alarm2.wav");
  messagebox(%player,"This server is equipped with an anti-stealth detection system. The slash on your name has been detected. All players have been alerted to your presence."); }
 say(%player, 0, "Welcome to S&S "@$missionname@" created by Velax.  Please read the rules carefully. Visit www.Sun and Shadows.com, your Starsiege community headquarters!"); }

function vehicle::onAdd(%this){
 if(getVehicleTechBase(%this) == "C" && getTeam(%this) != *IDSTR_TEAM_PURPLE){ randomDrop(%this); }
 if($server::TeamPlay != true){
  %player = playerManager::vehicleIdToPlayerNum(%this);
  if(%player == 0){ return; }
  setTeam(%this, *IDSTR_TEAM_YELLOW); }
 %player.hitstaken = 0;
 %player.hitsdealt = 0; }

function vehicle::onattacked(%v, %w){
 %player = playerManager::vehicleIdToPlayerNum(%v);
 %player2 = playerManager::vehicleIdToPlayerNum(%w);
 if(%player == %player2){ return; }
 if((getTeam(%player) == getTeam(%player2)) && ($server::teamplay == true)){ return; }
 %player.hitstaken++;
 %player2.hitsdealt++; }

function getPlayerScore(%a){ return((getKills(%a) * $killPoints) - (getDeaths(%a) * $deathPoints) + (%a.hitstaken / 50) + (%a.hitsdealt / 25)); }

function getTeamScore(%a){ return((getTeamKills(%a) * $killPoints) - (getTeamDeaths(%a) * $deathPoints)); }

function getHitsTaken(%a){ return(%a.hitsTaken); }

function getHitsDealt(%a){ return(%a.hitsDealt); }

function initScoreBoard(){
 deleteVariables("$ScoreBoard::PlayerColumn*");
 deleteVariables("$ScoreBoard::TeamColumn*");
 if($server::TeamPlay == "True"){
  $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_TEAM;
  $ScoreBoard::PlayerColumnHeader2 = "Score";
  $ScoreBoard::PlayerColumnHeader3 = "Hits Taken";
  $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_KILLS;
  $ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_DEATHS;
  $ScoreBoard::PlayerColumnHeader6 = "Hits Dealt";
  $ScoreBoard::PlayerColumnHeader7 = *IDMULT_SCORE_SQUAD;
  $ScoreBoard::PlayerColumnFunction1 = "getTeam";
  $ScoreBoard::PlayerColumnFunction2 = "getPlayerScore";
  $ScoreBoard::PlayerColumnFunction3 = "getHitsTaken";
  $ScoreBoard::PlayerColumnFunction4 = "getKills";
  $ScoreBoard::PlayerColumnFunction5 = "getDeaths";
  $ScoreBoard::PlayerColumnFunction6 = "getHitsDealt";
  $ScoreBoard::PlayerColumnFunction7 = "getSquad"; }
 else{
  $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_SQUAD;
  $ScoreBoard::PlayerColumnHeader2 = "Score";
  $ScoreBoard::PlayerColumnHeader3 = "Hits Taken";
  $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_KILLS;
  $ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_DEATHS;
  $ScoreBoard::PlayerColumnHeader6 = "Hits Dealt";
  $ScoreBoard::PlayerColumnFunction1 = "getSquad";
  $ScoreBoard::PlayerColumnFunction2 = "getPlayerScore";
  $ScoreBoard::PlayerColumnFunction3 = "getHitsTaken";
  $ScoreBoard::PlayerColumnFunction4 = "getKills";
  $ScoreBoard::PlayerColumnFunction5 = "getDeaths";
  $ScoreBoard::PlayerColumnFunction6 = "getHitsDealt"; }
 $ScoreBoard::TeamColumnHeader1 = *IDMULT_SCORE_SCORE;
 $ScoreBoard::TeamColumnHeader2 = *IDMULT_SCORE_PLAYERS;
 $ScoreBoard::TeamColumnHeader3 = *IDMULT_SCORE_KILLS;
 $ScoreBoard::TeamColumnHeader4 = *IDMULT_SCORE_DEATHS;
 $ScoreBoard::TeamColumnFunction1 = "getTeamScore";
 $ScoreBoard::TeamColumnFunction2 = "getNumberOfPlayersOnTeam";
 $ScoreBoard::TeamColumnFunction3 = "getTeamKills";
 $ScoreBoard::TeamColumnFunction4 = "getTeamDeaths";
 serverInitScoreBoard(); }

//
